/*
* Licensed Materials - Property of IBM Corp.
* IBM UrbanCode Build
* IBM UrbanCode Deploy
* IBM UrbanCode Release
* IBM AnthillPro
* (c) Copyright IBM Corporation 2002, 2013. All Rights Reserved.
*
* U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by
* GSA ADP Schedule Contract with IBM Corp.
*/
import java.io.*;
import java.util.*;
import com.urbancode.air.plugin.websphere.WebSphereBatchScriptHelper

final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()
out = System.out;
def wsadmin = isWindows ? "wsadmin.bat" : "wsadmin.sh"

final def workDir = new File('.').canonicalFile
final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

def appName = props['appName'];
def appEdition = props['appEdition'];
def appClassLoader = props['appClassLoader']?.trim();
def warClassLoader = props['warClassLoader']?.trim();

if (appClassLoader == null || (appClassLoader != "PARENT_FIRST" && appClassLoader != "PARENT_LAST")) {
    throw new IllegalArgumentException("Application ClassLoader must be PARENT_FIRST or PARENT_LAST not ${warClassLoader}");
}

if (warClassLoader == null || (warClassLoader != "PARENT_FIRST" && warClassLoader != "PARENT_LAST")) {
    throw new IllegalArgumentException("WebModule ClassLoader must be PARENT_FIRST or PARENT_LAST not ${warClassLoader}");
}

StringBuilder builder = new StringBuilder();
builder.append("modifyClassLoaders(")
           .append("\"").append(appName).append("\"").append(",")
           .append("\"").append(appEdition?:"").append("\"").append(",")
           .append("\'").append(appClassLoader).append("\'").append(",")
           .append("\'").append(warClassLoader).append("\'")
       .append(")")
command = builder.toString();

WebSphereBatchScriptHelper helper = new WebSphereBatchScriptHelper(props);
helper.execute(command);
